package com.lpdp.del.tenunapp.dependency.network;

import com.lpdp.del.tenunapp.dependency.models.RequestBodyGenerateImg;
import com.lpdp.del.tenunapp.dependency.models.RequestBodyGenerateImg2;
import com.lpdp.del.tenunapp.dependency.models.ResponseGenerateFile;
import com.lpdp.del.tenunapp.dependency.models.ResponseGetAlgoritma;
import com.lpdp.del.tenunapp.dependency.models.ResponseGetData;
import com.lpdp.del.tenunapp.dependency.models.ResponseGetDataMotif;
import com.lpdp.del.tenunapp.dependency.models.ResponseGetDataMotifTenun;
import com.lpdp.del.tenunapp.dependency.models.ResponseGetGeneratedImage;
import com.lpdp.del.tenunapp.dependency.models.ResponseKristik;
import com.lpdp.del.tenunapp.dependency.models.ResponseKristikFile;
import com.lpdp.del.tenunapp.dependency.modules.APIModule;

import okhttp3.MultipartBody;
import okhttp3.RequestBody;
import retrofit2.Call;
import retrofit2.http.Body;
import retrofit2.http.Field;
import retrofit2.http.FormUrlEncoded;
import retrofit2.http.GET;
import retrofit2.http.Header;
import retrofit2.http.Multipart;
import retrofit2.http.POST;
import retrofit2.http.Part;
import retrofit2.http.Query;

/**
 * Using this file must on behalf of Institut Teknologi Del & Piksel
 */
public interface TenunNetworkInterface {
    @GET("tenun")
    Call<ResponseGetData> getListTenun(@Header("Authorization") String token, @Query("cursor") int cursor, @Query("size") int size);

    @GET("tenun")
    Call<ResponseGetData> getListTenun(@Header("Authorization") String token, @Query("cursor") int cursor, @Query("size") String size);

    @GET("motifTenun")
    Call<ResponseGetDataMotif> getListMotif(@Header("Authorization") String token, @Query("cursor") int cursor, @Query("size") String size);

    @GET("listGenerate")
    Call<ResponseGenerateFile> getListGenerate(@Header("Authorization") String token);

    @GET("motifTenunById")
    Call<ResponseGetData> getMotifTenunById(@Header("Authorization") String token, @Field("id") int id);

    @POST("generateImg")
    Call<ResponseGetGeneratedImage> generateImg(@Header("Authorization") String key, @Body RequestBodyGenerateImg body);

    @GET("algoritmaWithParameter")
    Call<ResponseGetAlgoritma> getAlgoritma(@Header("Authorization") String token);

    @POST("generateNewMotif")
    Call<ResponseGetGeneratedImage> generateNewMotif(
            @Header("Authorization") String token,
            @Body RequestBodyGenerateImg2 body
    );

    @FormUrlEncoded
    @POST("kristikDigital")
    Call<ResponseKristik> kristikDigital(
            @Header("Authorization") String token,
            @Field("squareSize") int squareSize,
            @Field("colorsAmount") int colorsAmount,
            @Field("target_file") String target_file
    );

    @FormUrlEncoded
    @POST("kristikDigitalAwal")
    Call<ResponseKristik> kristikDigitalAwal(
            @Header("Authorization") String token,
            @Field("squareSize") int squareSize,
            @Field("colorsAmount") int colorsAmount,
            @Field("target_file") String target_file
    );

    @Multipart
    @POST("uploadImage")
    Call<ResponseGetDataMotifTenun> uploadImage(
            @Header("Authorization") String token,
            @Part("nama_motif") String nama_motif,
            @Part("id_tenun") int id_tenun,
            @Part MultipartBody.Part photo
    );

    @Multipart
    @POST("ulosclassify")
    Call<BaseResponse> classifyUlos(
            @Header("Authorization") String token,
            @Part MultipartBody.Part photo
    );


    @Multipart
    @POST("chekBlur")
    Call<BaseResponse> checkBlur(@Header("Authorization") String token, @Part MultipartBody.Part photo);


    @POST("CheckNoise")
    Call<BaseResponse> checkNoise(@Header("Authorization") String token, @Body MultipartBody.Part photo);

}
