package com.lpdp.del.tenunapp.function.generate;

import android.content.Context;
import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.GridLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.view.Menu;

import com.lpdp.del.tenunapp.R;
import com.lpdp.del.tenunapp.R2;
import com.lpdp.del.tenunapp.dependency.App;
import com.lpdp.del.tenunapp.dependency.models.Generate;
import com.lpdp.del.tenunapp.dependency.models.MotifTenun;
import com.lpdp.del.tenunapp.dependency.network.TenunNetworkInterface;
import com.lpdp.del.tenunapp.function.MiscActivity;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import javax.inject.Inject;

import butterknife.BindView;
import butterknife.ButterKnife;
import io.realm.Realm;
import io.realm.Sort;
import timber.log.Timber;

public class GenerateActivity extends AppCompatActivity {
    public static final String KEY_ID_MOTIF = "id_motif_key";

    @Inject
    TenunNetworkInterface tenunNetworkInterface;
    @Inject
    Realm realm;
    List<Generate> listGenerate= Collections.EMPTY_LIST;
    String idMotif;
    Toolbar toolbar;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_generate);
        listGenerate = new ArrayList<Generate>();
        App.get(getApplicationContext()).getInjector().inject(this);
        ButterKnife.bind(this);
        Intent returnIntent = getIntent();
        idMotif = returnIntent.getStringExtra(KEY_ID_MOTIF);



        Timber.i("id motif : " + idMotif);
        listGenerate = realm.where(Generate.class).equalTo("idMotif",idMotif).findAll().sort("id", Sort.DESCENDING);

        RecyclerView myrv = (RecyclerView) findViewById(R.id.recyclerviewulos_id);
        RecyclerViewAdapterGenerate myAdapter = new RecyclerViewAdapterGenerate(this, listGenerate);
        myrv.setLayoutManager(new GridLayoutManager(this, 1));
        myrv.setAdapter(myAdapter);

        toolbar = (Toolbar)findViewById(R.id.toolbarGenerate);
        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
    }

    public static Intent createIntent(Context context, String id_motif) {
        Intent intent = new Intent(context, GenerateActivity.class);
        intent.putExtra(KEY_ID_MOTIF, id_motif);
        return intent;
    }

}
