package com.lpdp.del.tenunapp.function.generate;

import android.content.Context;
import android.content.Intent;
import android.support.v7.widget.CardView;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.engine.DiskCacheStrategy;
import com.lpdp.del.tenunapp.R;
import com.lpdp.del.tenunapp.dependency.models.Generate;
import com.lpdp.del.tenunapp.dependency.modules.APIModule;
import com.lpdp.del.tenunapp.function.kristik.KristikDigitalActivity;
import com.squareup.picasso.*;

import java.util.List;

public class RecyclerViewAdapterGenerate extends RecyclerView.Adapter<RecyclerViewAdapterGenerate.MyViewHolder> {

    private Context mContext ;
    private List<Generate> mData ;

    public RecyclerViewAdapterGenerate(Context mContext, List<Generate> mData) {
        this.mContext = mContext;
        this.mData = mData;
    }

    @Override
    public MyViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {

        View view ;
        LayoutInflater mInflater = LayoutInflater.from(mContext);
        view = mInflater.inflate(R.layout.recyclerview_generate,parent,false);
        return new MyViewHolder(view);
    }

    @Override
    public void onBindViewHolder(MyViewHolder holder, final int position) {

        int models = position+1;
        holder.model_generate.setText("Model "+models);
        String imgUrl = APIModule.ENDPOINT + mData.get(position).getGenerateFile();
        Glide glide = null;

        glide.with(holder.hasil_generate.getContext())
                .load(imgUrl)
                .diskCacheStrategy(DiskCacheStrategy.SOURCE)
                .override(800, 500)
                .centerCrop()
                .fitCenter()
                .crossFade()
                .into(holder.hasil_generate);

        holder.hasil_generate.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                mContext.startActivity(KristikDigitalActivity.createIntent(mContext,  mData.get(position).getId()));
            }
        });
    }

    @Override
    public int getItemCount() {
        return mData.size();
    }

    public static class MyViewHolder extends RecyclerView.ViewHolder {

        TextView model_generate;
        ImageView hasil_generate;
        CardView cardView ;

        public MyViewHolder(View itemView) {
            super(itemView);

            model_generate = (TextView) itemView.findViewById(R.id.model_generate);
            hasil_generate = (ImageView) itemView.findViewById(R.id.hasil_generate);
            cardView = (CardView) itemView.findViewById(R.id.cardviewulos_id);
        }
    }
}

