package com.lpdp.del.tenunapp.function.kristik;

import android.Manifest;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.os.Build;
import android.provider.MediaStore;
import android.support.annotation.NonNull;
import android.support.design.widget.CoordinatorLayout;
import android.support.design.widget.Snackbar;
import android.support.v4.app.ActivityCompat;
import android.support.v4.app.NavUtils;
import android.support.v4.app.TaskStackBuilder;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;

import com.afollestad.materialdialogs.MaterialDialog;
import com.bumptech.glide.Glide;
import com.bumptech.glide.load.engine.DiskCacheStrategy;
import com.bumptech.glide.load.resource.bitmap.GlideBitmapDrawable;
import com.bumptech.glide.request.animation.GlideAnimation;
import com.bumptech.glide.request.target.SimpleTarget;
import com.bumptech.glide.request.target.Target;
import com.joanzapata.iconify.widget.IconTextView;
import com.lpdp.del.tenunapp.R;
import com.lpdp.del.tenunapp.R2;
import com.lpdp.del.tenunapp.dependency.App;
import com.lpdp.del.tenunapp.dependency.models.Algoritma;
import com.lpdp.del.tenunapp.dependency.models.Generate;
import com.lpdp.del.tenunapp.dependency.models.Kristik;
import com.lpdp.del.tenunapp.dependency.models.ResponseKristik;
import com.lpdp.del.tenunapp.dependency.modules.APIModule;
import com.lpdp.del.tenunapp.dependency.network.TenunNetworkInterface;
import com.lpdp.del.tenunapp.function.imageproc.PreviewActivity;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.inject.Inject;

import butterknife.BindView;
import butterknife.ButterKnife;
import io.realm.Realm;
import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;
import timber.log.Timber;

public class KristikDigitalActivity extends AppCompatActivity {
    public static final String KEY_ID_MOTIF = "id_motif_key";
    private static final String KEY_BUNDLE_SAVED_URL = "keyGeneratedURL";
    private static final int REQUEST_WRITE_STORAGE = 112;

    public static String OUTPUT_SIZE = "output_size";
    public static String OUTPUT_SHAPE = "output_shape";
    public static String SUM_OF_MATRIX = "sum_of_matrix";
    public static String COLOR = "color";
    @Inject
    Realm realm;
    @Inject
    TenunNetworkInterface tenunNetworkInterface;

    @BindView(R2.id.toolbarDetailMotif)
    Toolbar toolbar;
    @BindView(R2.id.thumbMotif)
    ImageView thumbMotif;
    @BindView(R2.id.textToolbarDetail)
    TextView textToolbar;
    @BindView(R2.id.coordinatorLayoutDetailMotif)
    CoordinatorLayout coordinatorLayout;
    @BindView(R2.id.dividerView)
    View dividerView;
    @BindView(R2.id.containerImgGenerated)
    ImageView containerGenerated;
    @BindView(R2.id.progressBarGenerateResult)
    ProgressBar progressBar;
    @BindView(R2.id.saveBtn)
    IconTextView btnSaveImg;
    @BindView(R2.id.titleResult)
    TextView titleResult;

    List<Object> listParamState = new ArrayList<>();
    MaterialDialog dialog2;
    Generate generate;
    MenuItem generateMenu;
    String generatedUrl = "";
    private Algoritma selectedAlgoritma;
    private HashMap<String, Object> paramValue = new HashMap<>();
    private String generatedImg;
    private String idGenerate;
    private String generateFile;
    private String nama_generate;
    private SeekBar seekBarSquare, seekBarColor;

    public static Intent createIntent(Context context, String id_motif) {
        Intent intent = new Intent(context, KristikDigitalActivity.class);
        intent.putExtra(KEY_ID_MOTIF, id_motif);

        return intent;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_kristik_digital);

        App.get(getApplicationContext()).getInjector().inject(this);
        ButterKnife.bind(this);

        Intent returnIntent = getIntent();
        idGenerate = returnIntent.getStringExtra(KEY_ID_MOTIF);
        Timber.i("id Generate : " + idGenerate);
        generate = realm.where(Generate.class)
                .equalTo("id", idGenerate)
                .findFirst();
        generateFile = generate.getGenerateFile();
        String imgUrl = APIModule.ENDPOINT + generateFile;
        nama_generate = generate.getNamaGenerate() + ".jpg";
        Glide.with(this)
                .load(imgUrl)
                .diskCacheStrategy(DiskCacheStrategy.SOURCE)
                .override(500, 500)
                .centerCrop()
                .fitCenter()
                .crossFade()
                .into(thumbMotif);
        thumbMotif.setOnClickListener(v -> startActivity(PreviewActivity.createIntent(getApplicationContext(), imgUrl)));
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.detail_kristik_menu, menu);

        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.action_kristik:
                generateMenu = item;
                generateMenu.setEnabled(false);
                createDialog();
                break;
            case R.id.home:
                Intent upIntent = NavUtils.getParentActivityIntent(this);
                if (NavUtils.shouldUpRecreateTask(this, upIntent)) {
                    // This activity is NOT part of this app's task, so create a new task
                    // when navigating up, with a synthesized back stack.
                    TaskStackBuilder.create(this)
                            // Add all of this activity's parents to the back stack
                            .addNextIntentWithParentStack(upIntent)
                            // Navigate up to the closest parent
                            .startActivities();
                } else {
                    // This activity is part of this app's task, so simply
                    // navigate up to the logical parent activity.
                    NavUtils.navigateUpTo(this, upIntent);
                }
                return true;
            default:
                break;
        }
        return super.onOptionsItemSelected(item);
    }

    private void createDialog() {
        View dialogView = LayoutInflater.from(this).inflate(R.layout.dialog_kristik, coordinatorLayout, false);

        dialog2 = new MaterialDialog.Builder(KristikDigitalActivity.this)
                .customView(dialogView, true)
                .build();

        dialog2.getWindow().setBackgroundDrawable(null);
        dialog2.getWindow().getAttributes().windowAnimations = R.style.DialogTransition;
        WindowManager.LayoutParams wlp = dialog2.getWindow().getAttributes();
        wlp.gravity = Gravity.TOP;
        wlp.width = WindowManager.LayoutParams.MATCH_PARENT;
        seekBarSquare = (MySeekBar)dialog2.findViewById(R.id.seekBar_square);
        seekBarColor = (MySeekBar)dialog2.findViewById(R.id.seekBar_color);
        seekBarSquare.setProgress(10);
        seekBarColor.setProgress(5);
        TextView textViewSquare = (TextView)dialog2.findViewById(R.id.textViewSquare);
        TextView textViewColor = (TextView)dialog2.findViewById(R.id.textViewColor);

        seekBarSquare.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                int val = (progress * (seekBar.getWidth() - 2 * seekBar.getThumbOffset())) / seekBar.getMax();
                textViewSquare.setText("" + progress);
                textViewSquare.setX(seekBar.getX() + val + seekBar.getThumbOffset() / 2);
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
            }
        });

        seekBarColor.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                int val = (progress * (seekBar.getWidth() - 2 * seekBar.getThumbOffset())) / seekBar.getMax();
                textViewColor.setText("" + progress);
                textViewColor.setX(seekBar.getX() + val + seekBar.getThumbOffset() / 2);
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
            }
        });

        Button btnConvert= (Button) dialog2.findViewById(R.id.buttonConvert);

        dialog2.setOnDismissListener(dialog -> generateMenu.setEnabled(true));
        btnConvert.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                int squareSize= seekBarSquare.getProgress();
                int colorsAmount = seekBarColor.getProgress();
//                String sourceFile = generateFile;
                generateKristikDigital(squareSize, colorsAmount, nama_generate);
                Toast.makeText(getApplicationContext(), "Input: "+squareSize+" " +colorsAmount+" " +generateFile+" ", Toast.LENGTH_LONG).show();
                dialog2.dismiss();
            }
        });
        dialog2.show();
    }

    private void saveImg() {
        GlideBitmapDrawable bitmapDrawable = (GlideBitmapDrawable) containerGenerated.getDrawable();
        Bitmap imgBitmap = bitmapDrawable.getBitmap();

        File filePath = android.os.Environment.getExternalStorageDirectory();
        File dir = new File(filePath.getAbsolutePath() + File.separator + "TenunKristik" + File.separator);

        if (!dir.exists())
            dir.mkdirs();

        File file = new File(dir, generatedImg);

        try {
            OutputStream outputStream = new FileOutputStream(file);
            imgBitmap.compress(Bitmap.CompressFormat.JPEG, 100, outputStream);
            outputStream.flush();
            outputStream.close();

            addImageToGallery(file.getAbsolutePath(), getApplicationContext());
        } catch (IOException ex) {
            Timber.i(ex.getMessage());
        }
    }

    private void generateKristikDigital(int squareSize, int colorsAmount, String sourceFile) {
        btnSaveImg.setVisibility(View.GONE);
        progressBar.setVisibility(View.VISIBLE);
        containerGenerated.setImageDrawable(null);

        tenunNetworkInterface.kristikDigital(APIModule.ACCESS_TOKEN_TEMP, squareSize, colorsAmount, sourceFile).enqueue(new Callback<ResponseKristik>() {
            @Override
            public void onResponse(Call<ResponseKristik> call, Response<ResponseKristik> response) {

                if (response.isSuccessful()) {
                    Kristik kristik = response.body().getData();
                    String newImgUrl = APIModule.ENDPOINT + kristik.getKristikFile();
                    generatedImg = response.body().getFileName();

                    Target target = new SimpleTarget() {
                        @Override
                        public void onResourceReady(Object resource, GlideAnimation glideAnimation) {
                            containerGenerated.setImageDrawable((Drawable) resource);
                            containerGenerated.setOnClickListener(v -> startActivity(PreviewActivity.createIntent(getApplicationContext(), newImgUrl)));
                            progressBar.setVisibility(View.GONE);
                            btnSaveImg.setVisibility(View.VISIBLE);


                            btnSaveImg.setOnClickListener(v -> {
                                boolean hasPermission = (ContextCompat.checkSelfPermission(getApplicationContext(),
                                        Manifest.permission.WRITE_EXTERNAL_STORAGE) == PackageManager.PERMISSION_GRANTED);

                                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
                                    if (!hasPermission) {
                                        ActivityCompat.requestPermissions(KristikDigitalActivity.this, new String[]{Manifest.permission.WRITE_EXTERNAL_STORAGE}, REQUEST_WRITE_STORAGE);
                                    } else {
                                        saveImg();
                                    }
                                } else {
                                    saveImg();
                                }
                            });
                        }
                    };
                    Glide.with(getApplicationContext())
                            .load(newImgUrl)
                            .centerCrop()
                            .fitCenter()
                            .diskCacheStrategy(DiskCacheStrategy.SOURCE)
                            .override(800, 500)
                            .into(target);

                    generatedUrl = kristik.getKristikFile();
                } else {
                    titleResult.setText("Error (" + response.code() + ")");
                    Snackbar snackbar = Snackbar.make(coordinatorLayout, "Error to convert", Snackbar.LENGTH_INDEFINITE);
                    snackbar.setAction("DISMISS", v -> {
                        snackbar.dismiss();
                        titleResult.setText(R.string.generated_text);
                    });
                    snackbar.show();
                    progressBar.setVisibility(View.GONE);

                    generateMenu.setEnabled(true);
                }
            }

            @Override
            public void onFailure(Call<ResponseKristik> call, Throwable t) {
                titleResult.setText(t.getLocalizedMessage());
                Snackbar snackbar = Snackbar.make(coordinatorLayout, "Error to convert", Snackbar.LENGTH_INDEFINITE);
                snackbar.setAction("DISMISS", v -> {
                    snackbar.dismiss();
                    titleResult.setText(R.string.generated_text);
                });
                snackbar.show();
                progressBar.setVisibility(View.GONE);

                generateMenu.setEnabled(true);
            }
        });
    }

    void addImageToGallery(final String filePath, final Context context) {

        ContentValues values = new ContentValues();

        values.put(MediaStore.Images.Media.DATE_TAKEN, System.currentTimeMillis());
        values.put(MediaStore.Images.Media.MIME_TYPE, "image/jpeg");
        values.put(MediaStore.MediaColumns.DATA, filePath);

        context.getContentResolver().insert(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, values);

        Toast.makeText(getApplicationContext(), getResources().getString(R.string.ack_image_saved), Toast.LENGTH_LONG).show();
    }

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        outState.putString(KEY_BUNDLE_SAVED_URL, generatedUrl);
        super.onSaveInstanceState(outState);
    }

    @Override
    protected void onRestoreInstanceState(Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);
        Glide.with(getApplicationContext())
                .load(savedInstanceState.getString(KEY_BUNDLE_SAVED_URL))
                .centerCrop()
                .fitCenter()
                .diskCacheStrategy(DiskCacheStrategy.SOURCE)
                .override(300, 300)
                .into(containerGenerated);
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        switch (requestCode) {
            case REQUEST_WRITE_STORAGE: {
                if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    saveImg();
                } else {
                    Toast.makeText(KristikDigitalActivity.this, "Please allow to write to storage", Toast.LENGTH_LONG).show();
                }
                break;
            }
        }
    }
}
