package com.lpdp.del.tenunapp.function.upload;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.kosalgeek.android.photoutil.CameraPhoto;
import com.kosalgeek.android.photoutil.ImageLoader;
import com.lpdp.del.tenunapp.R;
import com.lpdp.del.tenunapp.R2;
import com.lpdp.del.tenunapp.dependency.App;
import com.lpdp.del.tenunapp.dependency.models.MotifTenun;
import com.lpdp.del.tenunapp.dependency.models.ResponseGetDataMotifTenun;
import com.lpdp.del.tenunapp.dependency.modules.APIModule;
import com.lpdp.del.tenunapp.dependency.network.BaseResponse;
import com.lpdp.del.tenunapp.dependency.network.TenunNetworkInterface;
import com.lpdp.del.tenunapp.dependency.utils.FileUtils;
import com.lpdp.del.tenunapp.function.browse.BrowseMotifActivity;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Collections;
import java.util.List;

import javax.inject.Inject;

import butterknife.BindView;
import butterknife.ButterKnife;
import io.realm.Realm;
import okhttp3.MediaType;
import okhttp3.MultipartBody;
import okhttp3.RequestBody;
import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class UploadActivity extends AppCompatActivity implements View.OnClickListener {
    private static String ACTION_TITLE_CONTINUE = "CONTINUE";
    private static String ACTION_TITLE_REFRESH = "REFRESH";
    private static final int PICK_IMAGE = 1;
    private static final int PERMISSION_REQUEST_STORAGE = 2;
    public  static final int RequestPermissionCode  = 1 ;
    private static final int PICK_FROM_CAMERA = 1;
    private static final int MY_CAMERA_REQUEST_CODE = 100;

    @Inject
    Realm realm;
    @Inject
    TenunNetworkInterface tenunNetworkInterface;
    @BindView(R2.id.textToolbarUpload)
    TextView textToolbarUpload;
    @BindView(R2.id.toolbarUpload)
    Toolbar toolbarUpload;

    private static final String TYPE_1 = "multipart";
    private static final String TYPE_2 = "base64";
    private TextView nama_motif;
    private ImageView img_thumb;
    private Button btnChoose;
    private Button btn_cekblur;
    private Button btn_ceknoise;
    private Button btn_upload;
    private Button btn_classify;
    List<MotifTenun> listMotif = Collections.EMPTY_LIST;
    private Button btn_take;
    private Spinner sp;
    private Uri uri;
    private ProgressBar spinner;
    CameraPhoto cameraPhoto;
    @BindView(R2.id.progressBarGenerateResult)
    ProgressBar progressBar;
    private TextView textClassify;
    final int CAMERA_REQUEST = 1;
    int id_tenun = 0;
    private String hasil = "";

    boolean cekBlur = false;
    boolean cekNoise = false;
    public static Intent createIntent(Context context) {
        return new Intent(context, UploadActivity.class);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_upload);
        App.get(getApplicationContext()).getInjector().inject(this);
        ButterKnife.bind(this);
        textToolbarUpload.setText("Upload Gambar");
        textClassify = (TextView)findViewById(R.id.textClassify);
        cameraPhoto = new CameraPhoto(getApplicationContext());
        btnChoose = (Button) findViewById(R.id.btn_choose);
        btn_take = (Button) findViewById(R.id.btn_take);
        img_thumb = (ImageView) findViewById(R.id.img_thumb);
        nama_motif = (TextView) findViewById(R.id.nama_motif);
        btn_upload = (Button) findViewById(R.id.btn_upload);
        btn_classify = (Button)findViewById(R.id.btn_classify);

//        textClassify.setText("");

        btn_upload.setOnClickListener(this);
        btnChoose.setOnClickListener(this);
        btn_take.setOnClickListener(this);
        btn_classify.setOnClickListener(this);


        final String dir = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PICTURES) + "/picFolder/";
        File newdir = new File(dir);
        newdir.mkdirs();

        realm.executeTransaction(new Realm.Transaction() {
            @Override
            public void execute(Realm realm) {
                listMotif = realm.copyFromRealm(realm.where(MotifTenun.class).findAll().sort("idTenun"));
            }
        });

    }


    @Override
    public void onClick(View view) {
        if (view == btnChoose) {
            cekNoise = cekBlur = false;
            choosePhoto();
        }
        else if (view == btn_take) {
            Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
            uri= Uri.fromFile(new File(Environment
                    .getExternalStorageDirectory(), "image_"
                    + String.valueOf(System.currentTimeMillis())
                    + ".jpg"));

            intent.putExtra(android.provider.MediaStore.EXTRA_OUTPUT,
                    uri);

            try {
                intent.putExtra("return-data", true);
                startActivityForResult(intent, PICK_FROM_CAMERA);
                img_thumb.setImageURI(uri);
            } catch (ActivityNotFoundException e) {
                e.printStackTrace();
            }
        }
        else if(view == btn_upload){
            openDialog();
        }else if(view == btn_classify){
            if(uri!=null){

                Toast.makeText(getApplicationContext(), "Sedang mengklasifikasikan", Toast.LENGTH_SHORT).show();
                File file = FileUtils.getFile(getApplicationContext(), uri);
                classifyUlos(file);
                progressBar.setVisibility(View.VISIBLE);
            }else{
                Toast.makeText(getApplicationContext(), "You must choose the image or take from camera", Toast.LENGTH_SHORT).show();
            }
        }
    }



    private void choosePhoto() {
        if (ContextCompat.checkSelfPermission(this, android.Manifest.permission.READ_EXTERNAL_STORAGE)
                != PackageManager.PERMISSION_GRANTED
                && ContextCompat.checkSelfPermission(this, android.Manifest.permission.WRITE_EXTERNAL_STORAGE)
                != PackageManager.PERMISSION_GRANTED) {

            ActivityCompat.requestPermissions(this,
                    new String[]{android.Manifest.permission.READ_EXTERNAL_STORAGE, android.Manifest.permission.WRITE_EXTERNAL_STORAGE},
                    PERMISSION_REQUEST_STORAGE);


        } else {
            openGallery();
        }
    }

    public void openGallery() {
        Intent intent = new Intent();
        intent.setType("image/*");
        intent.setAction(Intent.ACTION_GET_CONTENT);
        startActivityForResult(Intent.createChooser(intent, "Select Image"), PICK_IMAGE);
    }

    public void openDialog(){
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        LayoutInflater inflater = this.getLayoutInflater();
        View view = inflater.inflate(R.layout.layout_dialog, null);
//        String[] items = new String[]{"Ulos Bintang Maratur", "Ulos Ragihotang", "Ulos Sibolang", "Ulos Harungguan", "Ulos Sadum", "Ulos Ragiidup", "Ulos Mangiring", "Ulos Sitoluntuho"};
//        final ArrayAdapter<String> adp = new ArrayAdapter<String>(this,
//                android.R.layout.simple_spinner_item, items);
//        sp = (Spinner) view.findViewById(R.id.nama_tenun);
//        sp.setAdapter(adp);
        nama_motif = (EditText) view.findViewById(R.id.nama_motif);
        builder.setView(view)
                .setTitle("Masukkan detail ulos")
                .setNegativeButton("cancel", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int i) {
                    }
                })
                .setPositiveButton("Submit", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int i) {

                        if (uri != null) {
                            File file = FileUtils.getFile(getApplicationContext(), uri);
                            Toast.makeText(getApplicationContext(), nama_motif.getText().toString() +" ", Toast.LENGTH_SHORT).show();
                            uploadImage(file);
                            progressBar.setVisibility(View.VISIBLE);
                        } else {
                            Toast.makeText(getApplicationContext(), "You must choose the image", Toast.LENGTH_SHORT).show();
                        }
                        dialog.dismiss();
                    }
                });
        builder.create();
        builder.show();
    }

    private boolean checkBlur(File file) {
        RequestBody photoBody = RequestBody.create(MediaType.parse("image/*"), file);
        MultipartBody.Part photoPart = MultipartBody.Part.createFormData("photo",
                file.getName(), photoBody);

        tenunNetworkInterface.checkBlur(APIModule.ACCESS_TOKEN_TEMP, photoPart).enqueue(new Callback<BaseResponse>() {
            @Override
            public void onResponse(Call<BaseResponse> call, Response<BaseResponse> response) {
                if(response.isSuccessful()){
                    BaseResponse baseResponse = (BaseResponse) response.body();
                    if(response.body().getMessage().equals("Good")){
                        cekBlur = true;
                    }
                    Toast.makeText(UploadActivity.this, baseResponse.getMessage(), Toast.LENGTH_SHORT).show();
                }
            }

            @Override
            public void onFailure(Call<BaseResponse> call, Throwable t) {
                Toast.makeText(getApplicationContext(), t.getLocalizedMessage(),Toast.LENGTH_SHORT).show();
            }
        });

        return cekBlur;
    }

    private void classifyUlos(File file){
        RequestBody photoBody = RequestBody.create(MediaType.parse("image/*"), file);
        MultipartBody.Part photoPart = MultipartBody.Part.createFormData("photo",
                file.getName(), photoBody);

        tenunNetworkInterface.classifyUlos(APIModule.ACCESS_TOKEN_TEMP,photoPart).enqueue(new Callback<BaseResponse>() {
            @Override
            public void onResponse(Call<BaseResponse> call, Response<BaseResponse> response) {
                BaseResponse baseResponse = (BaseResponse) response.body();
                if(response.isSuccessful()) {
                    hasil = baseResponse.getMessage();
                    if(hasil.equals("Ulos Bintang Maratur"))id_tenun = 4;
                    else if(hasil.equals("Ulos Ragihotang"))id_tenun = 5;
                    else if(hasil.equals("Ulos Sibolang"))id_tenun = 6;
                    else if(hasil.equals("Ulos Harungguan"))id_tenun = 10;
                    else if(hasil.equals("Ulos Sadum"))id_tenun = 15;
                    else if(hasil.equals("Ulos Ragiidup"))id_tenun = 16;
                    else if(hasil.equals("Ulos Mangiring"))id_tenun = 23;
                    else if(hasil.equals("Ulos Sitoluntuho"))id_tenun = 24;
                    textClassify.setText(hasil);
                    progressBar.setVisibility(View.GONE);
                    Toast.makeText(UploadActivity.this, baseResponse.getMessage(), Toast.LENGTH_SHORT).show();
                }
            }

            @Override
            public void onFailure(Call<BaseResponse> call, Throwable t) {
                Toast.makeText(getApplicationContext(), t.getLocalizedMessage(),Toast.LENGTH_SHORT).show();
            }
        });
//        return hasil;

    }

    private boolean checkNoise(File file) {
        RequestBody photoBody = RequestBody.create(MediaType.parse("image/*"), file);
        MultipartBody.Part photoPart = MultipartBody.Part.createFormData("photo",
                file.getName(), photoBody);

        tenunNetworkInterface.checkNoise(APIModule.ACCESS_TOKEN_TEMP,photoPart).enqueue(new Callback<BaseResponse>() {
            @Override
            public void onResponse(Call<BaseResponse> call, Response<BaseResponse> response) {
                BaseResponse baseResponse = (BaseResponse) response.body();
                if(response.isSuccessful()) {
                    cekNoise = true;

                    Toast.makeText(UploadActivity.this, baseResponse.getMessage(), Toast.LENGTH_SHORT).show();
                }
            }

            @Override
            public void onFailure(Call<BaseResponse> call, Throwable t) {
                Toast.makeText(getApplicationContext(), t.getLocalizedMessage(),Toast.LENGTH_SHORT).show();
            }
        });
        return cekNoise;
    }

    private void uploadImage(File file) {
        RequestBody photoBody = RequestBody.create(MediaType.parse("image/*"), file);
        MultipartBody.Part photoPart = MultipartBody.Part.createFormData("photo",
                file.getName(), photoBody);

//        if(sp.getSelectedItem().toString().equals("Ulos Bintang Maratur"))this.id_tenun = 4;
//        else if(sp.getSelectedItem().toString().equals("Ulos Ragihotang"))this.id_tenun = 5;
//        else if(sp.getSelectedItem().toString().equals("Ulos Sibolang"))this.id_tenun = 6;
//        else if(sp.getSelectedItem().toString().equals("Ulos Harungguan"))this.id_tenun = 10;
//        else if(sp.getSelectedItem().toString().equals("Ulos Sadum"))this.id_tenun = 15;
//        else if(sp.getSelectedItem().toString().equals("Ulos Ragiidup"))this.id_tenun = 16;
//        else if(sp.getSelectedItem().toString().equals("Ulos Mangiring"))this.id_tenun = 23;
//        else if(sp.getSelectedItem().toString().equals("Ulos Sitoluntuho"))this.id_tenun = 24;

            tenunNetworkInterface.uploadImage(APIModule.ACCESS_TOKEN_TEMP, this.nama_motif.getText().toString(), this.id_tenun, photoPart).enqueue(new Callback<ResponseGetDataMotifTenun>() {
                @Override
                public void onResponse(Call<ResponseGetDataMotifTenun> call, Response<ResponseGetDataMotifTenun> response) {
                    ResponseGetDataMotifTenun responseGetDataMotifTenun = (ResponseGetDataMotifTenun) response.body();
                    if(responseGetDataMotifTenun != null) {
                        progressBar.setVisibility(View.GONE);
                        MotifTenun motifTenun = responseGetDataMotifTenun.getMotifTenun();
                        listMotif.add(motifTenun);
                        realm.beginTransaction();
                        realm.executeTransactionAsync(realmInstance -> realmInstance.insertOrUpdate(listMotif));
                        realm.commitTransaction();
                        Toast.makeText(getApplicationContext(), responseGetDataMotifTenun.getMessage(), Toast.LENGTH_SHORT).show();
                        startActivity(BrowseMotifActivity.createIntent(getApplicationContext()));
                        UploadActivity.this.finish();
                    }
                }

                @Override
                public void onFailure(Call<ResponseGetDataMotifTenun> call, Throwable t) {
                    Toast.makeText(getApplicationContext(), t.getLocalizedMessage(),Toast.LENGTH_SHORT).show();
                }
            });
    }




    @Override
    public void onRequestPermissionsResult(int requestCode,@NonNull String permissions[],@NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        switch (requestCode) {
            case PERMISSION_REQUEST_STORAGE: {
                // If request is cancelled, the result arrays are empty.
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {

                    openGallery();
                }
            }
            case MY_CAMERA_REQUEST_CODE: {
                if (grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    Toast.makeText(this, "camera permission granted", Toast.LENGTH_LONG).show();
                } else {
                    Toast.makeText(this, "camera permission denied", Toast.LENGTH_LONG).show();
                }
            }
        }
        return;
    }


    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        switch (requestCode) {
            case 0:
                if (resultCode == RESULT_OK) {
                    if (requestCode == CAMERA_REQUEST) {
                        String photoPath = cameraPhoto.getPhotoPath();
                        try {
                            Bitmap bitmap = ImageLoader.init().from(photoPath).requestSize(512, 512).getBitmap();
                            img_thumb.setImageBitmap(bitmap);
                        } catch (FileNotFoundException e) {
                            Toast.makeText(getApplicationContext(), "Something Wrong while loading photos", Toast.LENGTH_SHORT).show();
                        }
                    } else if (requestCode == PICK_IMAGE && resultCode == Activity.RESULT_OK) {
                        if (data != null) {
                            uri = data.getData();

                            img_thumb.setImageURI(uri);
                        }
                    }
                }
                break;

            case 1:
                if (requestCode == PICK_IMAGE && resultCode == Activity.RESULT_OK) {
                    if (data != null) {
                        uri = data.getData();

                        img_thumb.setImageURI(uri);
                    }
                }
                else if (requestCode == PICK_FROM_CAMERA) {
                    if (data != null) {
                        uri = data.getData();

                        img_thumb.setImageURI(uri);
                    }

                }
                break;
        }
    }

    // Requesting runtime permission to access camera.
    public void EnableRuntimePermissionToAccessCamera(){

        if (ActivityCompat.shouldShowRequestPermissionRationale(UploadActivity.this,
                Manifest.permission.CAMERA))
        {

            // Printing toast message after enabling runtime permission.
            Toast.makeText(UploadActivity.this,"CAMERA permission allows us to Access CAMERA app", Toast.LENGTH_LONG).show();

        } else {

            ActivityCompat.requestPermissions(UploadActivity.this,new String[]{Manifest.permission.CAMERA}, RequestPermissionCode);

        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.filter_activity_menu, menu);
        return true;
    }
}

